//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+


#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Joe Farmer Built with Free On Line Builder and Added Code"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

#define  NL    "\n"
extern bool      use_daily_target=false;
extern double    daily_target=100;
extern bool UseRSI = False;
extern double rsiselllevel = 75;
extern double rsibuylevel = 25;
extern bool UseCCI = False;
extern double cciselllevel = 100;
extern double ccibuylevel = -100;
extern double Account_Drawdown_Exit_Percent = 100;
extern bool Trade_Fixed_Lots = false;
extern double Max_Lot_Size = 2.0;
extern bool Trade_Martingale_Increments = false;
extern double Starting_Lot_Size = 0.01;
extern double LotIncrement = 0.01;
extern bool Trade_Full_Martingale = true;
extern int Slippage = 3;
extern double  Profit_Target_Dollars= 20.0;
extern bool PrintProfitToScreen = False;
extern int     MagicNumber = 0;
extern bool    ApplyToAllSymbols = true; // if ApplyToAllSymbols = false, just close the symbol you are applying your EA; if ApplyToAllSymbols = true, it will close all symbol satisfying the upper condition.


bool    CloseOpenLongOrders = True; // if close open positions
bool    CloseOpenShortOrders = True; // if close open positions
bool    ClosePendingLongOrders = true;
bool    ClosePendingShortOrders = true;
bool    CloseAllPendingOpenLongShort = false; // efficient to ClosePendingLongOrders + ClosePendingShortOrders + CloseOpenLongOrders + CloseOpenShortOrders all, just for convenient.

int BarCount;
int Count = 0;
int Current;
bool TickCheck = False;
bool EachTickMode = False;
double templots = 0.01;
string         Gap, ScreenMessage;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
{
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}


//+------------------------------------------------------------------------+
//| closes  orders                                                      |
//+------------------------------------------------------------------------+
void CloseOrders()
{ // Goes with For End
 
   double accountbalance = AccountBalance();
   double profit=0;
   for(int j=0; j<OrdersTotal(); j++)
   {
      OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MagicNumber || OrderType()>1) continue;
      profit+=OrderProfit();
   }
  if(profit>=Profit_Target_Dollars || profit <= accountbalance * (Account_Drawdown_Exit_Percent/100) *(-1) ) 
    
  { // Close Orders Start
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type    = OrderType();
    bool result = false;

    if ( ( OrderSymbol()==Symbol() || ApplyToAllSymbols == true ) && ( OrderMagicNumber() == MagicNumber || MagicNumber == 0 ) ) // only look if mygrid and symbol...
    {
   
      
/////////////////////////////////////////////   
       if(profit>=Profit_Target_Dollars || profit <= accountbalance * (Account_Drawdown_Exit_Percent/100) *(-1) ) 
       {
         
          if (CloseOpenLongOrders)
             {
               switch(type)
                 {
                   case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );  break;
                 }
             }
           
         if (CloseOpenShortOrders)
               {
                 switch(type)
                   {
                    //Close opened short positions
                    case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );  break; 
                   
                   }
               }
           
         // close pending orders    
             if (CloseAllPendingOpenLongShort || ClosePendingLongOrders )
           {
            switch(type)
               {
                  //Close pending orders
                  case OP_BUYLIMIT  : result = OrderDelete( OrderTicket() ); break;
                  case OP_BUYSTOP   : result = OrderDelete( OrderTicket() ); break;
                         
               }  
           }
                
         // close pending Short orders
         if (CloseAllPendingOpenLongShort || ClosePendingShortOrders  )
         {
            switch(type)
            {
               //Close pending orders
               case OP_SELLLIMIT : result = OrderDelete( OrderTicket() ); break;
               case OP_SELLSTOP  : result = OrderDelete( OrderTicket() ); break;
           
            }
         }  
              
               
       } // End If Profit >
      } // if symgol and magicnumber control end here
               
    
       if(result == false)
       {

       }  
   } //end closeorder start  
 } //for end here
  
  return;
}


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{
   if(use_daily_target && dailyprofit()>=daily_target)
   {
     Comment("\ndaily target achieved.");
     return(0);
   }


   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   double medianentry = Low[1] + (High[1] - Low[1])/2;
   
   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //---- 
   int i;
   CloseOrders();
   
 //  double williams = iWPR(NULL, 0, 250, Current + 1);

double rsi = iRSI(NULL, 0, 14, PRICE_CLOSE, Current + 1);
double cci = iCCI(NULL, 0, 14, PRICE_CLOSE, Current + 1);

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+
if(UseRSI==true && UseCCI == false)
{
    if (rsi < rsibuylevel)  Order = SIGNAL_BUY;
    if (rsi > rsiselllevel) Order = SIGNAL_SELL;
}
    
if(UseCCI ==true && UseRSI == false)
{
    if (cci < ccibuylevel)  Order = SIGNAL_BUY;
    if (cci > cciselllevel) Order = SIGNAL_SELL;
}
if(UseRSI == true && UseCCI == true)
{
  if (rsi < rsibuylevel && cci < ccibuylevel) Order = SIGNAL_BUY;
  if (rsi > rsiselllevel && cci > cciselllevel) Order = SIGNAL_SELL;
}
   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   
   //+------------------------------------------------------------------+
   //| Begin Screen Print                                                     |
   //+------------------------------------------------------------------+

     double profit=0;
     for(int j=0; j<OrdersTotal(); j++)
   {
      OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MagicNumber || OrderType()>1) continue;
      profit+=OrderProfit();
      if (profit == 0 && templots > Max_Lot_Size) templots = Starting_Lot_Size;  
   }
      
      if(PrintProfitToScreen == true) 
      {
      string ls_352 = "\n---------------------------------------------------------------------------------------------------";
      ls_352 = ls_352 
      + "\n    - Current Profit " + Symbol() + " : " + DoubleToStr(profit, 2);
      ls_352 = ls_352 
   + "\n    - Current Balance : " + DoubleToStr(AccountBalance(), 2);
      ls_352 = ls_352 
      + "\n    - TempLots " + Symbol() + " : " + DoubleToStr(templots, 2);
       Comment(ls_352);
      }
      

   //+------------------------------------------------------------------+
   //| Profit End                                                       |
   //+------------------------------------------------------------------+
   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
   
       {
         if(Trade_Martingale_Increments == true)
           {
              //Check free margin
              if (AccountFreeMargin() > (100 )
              && templots < Max_Lot_Size) 
               {
                templots = templots + LotIncrement; 
               }
               if(profit == 0) templots = Starting_Lot_Size;
               if(profit == 0 && templots < Max_Lot_Size) templots = Starting_Lot_Size;
           }
            
          if(Trade_Fixed_Lots == true)
             {
               if (AccountFreeMargin() > (100 )
               && templots < Max_Lot_Size) 
                 {
                    templots = Starting_Lot_Size; 
                 }
                 if(profit == 0) templots = Starting_Lot_Size;
                 if(profit == 0 && templots < Max_Lot_Size) templots = Starting_Lot_Size;
             }
          
          if(Trade_Full_Martingale == true)
             {
               if (AccountFreeMargin() > (100 )
               && templots < Max_Lot_Size) 
                 {
                    templots = templots*2; 
                 }
                 if(profit == 0) templots = Starting_Lot_Size;
                 if(profit == 0 && templots < Max_Lot_Size) templots = Starting_Lot_Size;
             }
          
      
         Ticket = OrderSend(Symbol(), OP_BUY, templots, Ask, Slippage, 0, 0, "StratName", MagicNumber, 0, DodgerBlue); // for modify test
   
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         Count = ((BarCount +1) - BarCount) + Count;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))))  {
  
      {
         if(Trade_Martingale_Increments == true)
           {
              //Check free margin
              if (AccountFreeMargin() > (100 )
              && templots < Max_Lot_Size) 
               {
                templots = templots + LotIncrement; 
               }
               if(profit == 0) templots = Starting_Lot_Size;
               if(profit == 0 && templots < Max_Lot_Size) templots = Starting_Lot_Size;
            }
            
          if(Trade_Fixed_Lots == true)
             {
               if (AccountFreeMargin() > (100 )
              && templots < Max_Lot_Size ) 
                 {
                    templots = Starting_Lot_Size; 
                 }
                 if(profit == 0) templots = Starting_Lot_Size;
                 if(profit == 0 && templots < Max_Lot_Size) templots = Starting_Lot_Size;
             }
          
          if(Trade_Full_Martingale == true)
             {
               if (AccountFreeMargin() > (100 )
               && templots < Max_Lot_Size) 
                 {
                    templots = templots*2; 
                 }
                 if(profit == 0) templots = Starting_Lot_Size;
                 if(profit == 0 && templots < Max_Lot_Size) templots = Starting_Lot_Size;
             }
       
          Ticket = OrderSend(Symbol(), OP_SELL, templots, Bid, Slippage, 0, 0, "StratName", MagicNumber, 0, DeepPink);
       
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
   
}
//+------------------------------------------------------------------+
double dailyprofit()
{
  int day=Day(); double res=0;
  for(int i=0; i<OrdersHistoryTotal(); i++)
  {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MagicNumber) continue;
      if(TimeDay(OrderOpenTime())==day) res+=OrderProfit();
  }
  return(res);
}
//+------------------------------------------------------------------+